## org.apache.mahout.math.matrix.impl
Class AbstractMatrix3D

    java.lang.Object
      org.apache.mahout.math.PersistentObject
          org.apache.mahout.math.matrix.impl.AbstractMatrix
              org.apache.mahout.math.matrix.impl.AbstractMatrix3D

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable

Deprecated. until unit tests are in place. Until this time, this class/interface is unsupported.

    @Deprecated
    public abstract class AbstractMatrix3D

extends AbstractMatrix

See Also:
  Serialized Form

Field Summary

Fields inherited from class org.apache.mahout.math.matrix.impl.AbstractMatrix
`isNoView`

Constructor Summary
`protected` `AbstractMatrix3D()` Deprecated. Makes this class non instantiable, but still let's others inherit from it.

Method Summary
`protected void` `checkBox(int slice, int row, int column, int depth, int height, int width)` Deprecated. Checks whether the receiver contains the given box and throws an exception, if necessary.
`protected void` `checkColumn(int column)` Deprecated. Sanity check for operations requiring a column index to be within bounds.
`protected void` `checkColumnIndexes(int[] indexes)` Deprecated. Checks whether indexes are legal and throws an exception, if necessary.
`protected void` `checkRow(int row)` Deprecated. Sanity check for operations requiring a row index to be within bounds.
`protected void` `checkRowIndexes(int[] indexes)` Deprecated. Checks whether indexes are legal and throws an exception, if necessary.
`void` `checkShape(AbstractMatrix3D B)` Deprecated. Sanity check for operations requiring two matrices with the same number of slices, rows and columns.
`void` `checkShape(AbstractMatrix3D B, AbstractMatrix3D C)` Deprecated. Sanity check for operations requiring matrices with the same number of slices, rows and columns.
`protected void` `checkSlice(int slice)` Deprecated. Sanity check for operations requiring a slice index to be within bounds.
`protected void` `checkSliceIndexes(int[] indexes)` Deprecated. Checks whether indexes are legal and throws an exception, if necessary.
`protected int` `columnOffset(int absRank)` Deprecated. Returns the position of the given absolute rank within the (virtual or non-virtual) internal 1-dimensional array.
`protected int` `columnRank(int rank)` Deprecated. Returns the absolute rank of the given relative rank.
`int` `columns()` Deprecated. Returns the number of columns.
`protected int` `index(int slice, int row, int column)` Deprecated. Returns the position of the given coordinate within the (virtual or non-virtual) internal 1-dimensional array.
`protected int` `rowOffset(int absRank)` Deprecated. Returns the position of the given absolute rank within the (virtual or non-virtual) internal 1-dimensional array.
`protected int` `rowRank(int rank)` Deprecated. Returns the absolute rank of the given relative rank.
`int` `rows()` Deprecated. Returns the number of rows.
`protected void` `setUp(int slices, int rows, int columns)` Deprecated. Sets up a matrix with a given number of slices and rows.
`protected void` `setUp(int slices, int rows, int columns, int sliceZero, int rowZero, int columnZero, int sliceStride, int rowStride, int columnStride)` Deprecated. Sets up a matrix with a given number of slices and rows and the given strides.
`protected int[]` `shape()` Deprecated.
`int` `size()` Deprecated. Returns the number of cells which is `slices()*rows()*columns()`.
`protected int` `sliceOffset(int absRank)` Deprecated. Returns the position of the given absolute rank within the (virtual or non-virtual) internal 1-dimensional array.
`protected int` `sliceRank(int rank)` Deprecated. Returns the absolute rank of the given relative rank.
`int` `slices()` Deprecated. Returns the number of slices.
`protected AbstractMatrix3D` `vColumnFlip()` Deprecated. Self modifying version of viewColumnFlip().
`protected AbstractMatrix3D` `vDice(int axis0, int axis1, int axis2)` Deprecated. Self modifying version of viewDice().
`protected AbstractMatrix3D` `vPart(int slice, int row, int column, int depth, int height, int width)` Deprecated. Self modifying version of viewPart().
`protected AbstractMatrix3D` `vRowFlip()` Deprecated. Self modifying version of viewRowFlip().
`protected AbstractMatrix3D` `vSliceFlip()` Deprecated. Self modifying version of viewSliceFlip().
`protected AbstractMatrix3D` `vStrides(int sliceStride, int rowStride, int columnStride)` Deprecated. Self modifying version of viewStrides().

Methods inherited from class org.apache.mahout.math.matrix.impl.AbstractMatrix
`ensureCapacity, isView, trimToSize`

Methods inherited from class org.apache.mahout.math.PersistentObject
`clone`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### AbstractMatrix3D

    protected AbstractMatrix3D()

  Deprecated.
  Makes this class non instantiable, but still let's others inherit from it.

Method Detail

### columnOffset

    protected int columnOffset(int absRank)

  Deprecated.
  Returns the position of the given absolute rank within the (virtual or non-virtual) internal 1-dimensional array. Default implementation. Override, if necessary.

  Parameters:
    `absRank` - the absolute rank of the element.
  Returns:
    the position.

### columnRank

    protected int columnRank(int rank)

  Deprecated.
  Returns the absolute rank of the given relative rank.

  Parameters:
    `rank` - the relative rank of the element.
  Returns:
    the absolute rank of the element.

### rowOffset

    protected int rowOffset(int absRank)

  Deprecated.
  Returns the position of the given absolute rank within the (virtual or non-virtual) internal 1-dimensional array. Default implementation. Override, if necessary.

  Parameters:
    `absRank` - the absolute rank of the element.
  Returns:
    the position.

### rowRank

    protected int rowRank(int rank)

  Deprecated.
  Returns the absolute rank of the given relative rank.

  Parameters:
    `rank` - the relative rank of the element.
  Returns:
    the absolute rank of the element.

### sliceOffset

    protected int sliceOffset(int absRank)

  Deprecated.
  Returns the position of the given absolute rank within the (virtual or non-virtual) internal 1-dimensional array. Default implementation. Override, if necessary.

  Parameters:
    `absRank` - the absolute rank of the element.
  Returns:
    the position.

### sliceRank

    protected int sliceRank(int rank)

  Deprecated.
  Returns the absolute rank of the given relative rank.

  Parameters:
    `rank` - the relative rank of the element.
  Returns:
    the absolute rank of the element.

### checkBox

    protected void checkBox(int slice,
                            int row,
                            int column,
                            int depth,
                            int height,
                            int width)

  Deprecated.
  Checks whether the receiver contains the given box and throws an exception, if necessary.

  Throws:
    `java.lang.IndexOutOfBoundsException` - if `row<0 || height<0 || row+height>rows || slice<0 || depth<0 || slice+depth>slices || column<0 || width<0 || column+width>columns`

### checkColumn

    protected void checkColumn(int column)

  Deprecated.
  Sanity check for operations requiring a column index to be within bounds.

  Throws:
    `java.lang.IndexOutOfBoundsException` - if `column < 0 || column >= columns()`.

### checkColumnIndexes

    protected void checkColumnIndexes(int[] indexes)

  Deprecated.
  Checks whether indexes are legal and throws an exception, if necessary.

  Throws:
    `java.lang.IndexOutOfBoundsException` - if `! (0 <= indexes[i] < columns())` for any i=0..indexes.length()-1.

### checkRow

    protected void checkRow(int row)

  Deprecated.
  Sanity check for operations requiring a row index to be within bounds.

  Throws:
    `java.lang.IndexOutOfBoundsException` - if `row < 0 || row >= rows()`.

### checkRowIndexes

    protected void checkRowIndexes(int[] indexes)

  Deprecated.
  Checks whether indexes are legal and throws an exception, if necessary.

  Throws:
    `java.lang.IndexOutOfBoundsException` - if `! (0 <= indexes[i] < rows())` for any i=0..indexes.length()-1.

### checkShape

    public void checkShape(AbstractMatrix3D B)

  Deprecated.
  Sanity check for operations requiring two matrices with the same number of slices, rows and columns.

  Throws:
    `java.lang.IllegalArgumentException` - if `slices() != B.slices() || rows() != B.rows() || columns() != B.columns()`.

### checkShape

    public void checkShape(AbstractMatrix3D B,
                           AbstractMatrix3D C)

  Deprecated.
  Sanity check for operations requiring matrices with the same number of slices, rows and columns.

  Throws:
    `java.lang.IllegalArgumentException` - if `slices() != B.slices() || rows() != B.rows() || columns() != B.columns() || slices() != C.slices() || rows() != C.rows() || columns() != C.columns()`.

### checkSlice

    protected void checkSlice(int slice)

  Deprecated.
  Sanity check for operations requiring a slice index to be within bounds.

  Throws:
    `java.lang.IndexOutOfBoundsException` - if `slice < 0 || slice >= slices()`.

### checkSliceIndexes

    protected void checkSliceIndexes(int[] indexes)

  Deprecated.
  Checks whether indexes are legal and throws an exception, if necessary.

  Throws:
    `java.lang.IndexOutOfBoundsException` - if `! (0 <= indexes[i] < slices())` for any i=0..indexes.length()-1.

### columns

    public int columns()

  Deprecated.
  Returns the number of columns.

### index

    protected int index(int slice,
                        int row,
                        int column)

  Deprecated.
  Returns the position of the given coordinate within the (virtual or non-virtual) internal 1-dimensional array.

  Parameters:
    `slice` - the index of the slice-coordinate.
    `row` - the index of the row-coordinate.
    `column` - the index of the third-coordinate.

### rows

    public int rows()

  Deprecated.
  Returns the number of rows.

### setUp

    protected void setUp(int slices,
                         int rows,
                         int columns)

  Deprecated.
  Sets up a matrix with a given number of slices and rows.

  Parameters:
    `slices` - the number of slices the matrix shall have.
    `rows` - the number of rows the matrix shall have.
    `columns` - the number of columns the matrix shall have.
  Throws:
    `java.lang.IllegalArgumentException` - if `(double)rows*slices > Integer.MAX_VALUE`.
    `java.lang.IllegalArgumentException` - if `slices<0 || rows<0 || columns<0`.

### setUp

    protected void setUp(int slices,
                         int rows,
                         int columns,
                         int sliceZero,
                         int rowZero,
                         int columnZero,
                         int sliceStride,
                         int rowStride,
                         int columnStride)

  Deprecated.
  Sets up a matrix with a given number of slices and rows and the given strides.

  Parameters:
    `slices` - the number of slices the matrix shall have.
    `rows` - the number of rows the matrix shall have.
    `columns` - the number of columns the matrix shall have.
    `sliceZero` - the position of the first element.
    `rowZero` - the position of the first element.
    `columnZero` - the position of the first element.
    `sliceStride` - the number of elements between two slices, i.e. `index(k+1,i,j)-index(k,i,j)`.
    `rowStride` - the number of elements between two rows, i.e. `index(k,i+1,j)-index(k,i,j)`.
    `columnStride` - the number of elements between two columns, i.e. `index(k,i,j+1)-index(k,i,j)`.
  Throws:
    `java.lang.IllegalArgumentException` - if `(double)slices*rows*columnss > Integer.MAX_VALUE`.
    `java.lang.IllegalArgumentException` - if `slices<0 || rows<0 || columns<0`.

### shape

    protected int[] shape()

  Deprecated.

### size

    public int size()

  Deprecated.
  Returns the number of cells which is `slices()*rows()*columns()`.

  Specified by:
    `size` in class `AbstractMatrix`

### slices

    public int slices()

  Deprecated.
  Returns the number of slices.

### vColumnFlip

    protected AbstractMatrix3D vColumnFlip()

  Deprecated.
  Self modifying version of viewColumnFlip().

### vDice

    protected AbstractMatrix3D vDice(int axis0,
                                     int axis1,
                                     int axis2)

  Deprecated.
  Self modifying version of viewDice().

  Throws:
    `java.lang.IllegalArgumentException` - if some of the parameters are equal or not in range 0..2.

### vPart

    protected AbstractMatrix3D vPart(int slice,
                                     int row,
                                     int column,
                                     int depth,
                                     int height,
                                     int width)

  Deprecated.
  Self modifying version of viewPart().

  Throws:
    `java.lang.IndexOutOfBoundsException` - if `slice<0 || depth<0 || slice+depth>slices() || row<0 || height<0 || row+height>rows() || column<0 || width<0 || column+width>columns()`

### vRowFlip

    protected AbstractMatrix3D vRowFlip()

  Deprecated.
  Self modifying version of viewRowFlip().

### vSliceFlip

    protected AbstractMatrix3D vSliceFlip()

  Deprecated.
  Self modifying version of viewSliceFlip().

### vStrides

    protected AbstractMatrix3D vStrides(int sliceStride,
                                        int rowStride,
                                        int columnStride)

  Deprecated.
  Self modifying version of viewStrides().

  Throws:
    `java.lang.IndexOutOfBoundsException` - if `sliceStride<=0 || rowStride<=0 || columnStride<=0`.

Copyright © 2008-2010 The Apache Software Foundation. All Rights Reserved.